<template>
  <div class="query-container">
    <div v-if="showQueryPage">
      <div slot="header" class="clearfix">
        <span>查詢紅利資料</span>
      </div>
      <div>
        <el-form :ref="formName" :model="model" label-position="left" label-width="150px">
          <el-form-item label="證照號碼" prop="custId">
            <el-input v-model="model.custId" placeholder="身份證號碼、護照號碼" />
          </el-form-item>
          <el-button type="primary" @click="onReset()">重置</el-button>
          <el-button type="primary" @click="onSubmit()">查詢</el-button>
        </el-form>
      </div>
    </div>
    <list
      v-if="!showQueryPage"
      :condition="model"
      :datalist="datalist"
      :visible.sync="showQueryPage"
      @doQuery="doQuery"
    />
  </div>
</template>

<script>
import { Message } from 'element-ui'
import { query } from '@/api/cust'
import json from '@/dataModel/query/custForm'
import List from './List'

export default {
  components: {
    List
  },
  data() {
    return {
      formName: 'form1',
      model: Object.assign({}, json),
      rules: null,
      showQueryPage: true,
      datalist: null
    }
  },
  methods: {
    doQuery: function(current) {
      this.model.current = current
      this.datalist = []

      var promise = query(this.model).then(response => {
        var status = response.status

        if (status === 'exception') {
          Message({
            message: response.data,
            showClose: true,
            type: 'error',
            duration: 3 * 1000
          })
        } else if (status === 'empty') {
          Message({
            message: '查無資料',
            showClose: true,
            type: 'success',
            duration: 3 * 1000
          })
          this.showQueryPage = true
        } else if (status === 'ok') {
          this.showQueryPage = false
          this.datalist = response.data
          this.model.total = response.total
        }
      })

      return promise
    },
    onSubmit() {
      this.$refs[this.formName].validate((valid) => {
        if (valid) {
          this.showQueryPage = false
          this.doQuery()
        } else {
          console.log('驗證未通過')
          return false
        }
      })
    },
    onReset() {
      this.$refs[this.formName].resetFields()
    }
  }
}
</script>
